//
//  NEXIndoorOutdoor.h
//  NumberEightCompiled
//
//  Created by Oliver Kocsis on 19/06/2018.
//  Copyright © 2018 NumberEight Technologies Ltd. All rights reserved.
//
#pragma once

#import "NEIndoorOutdoor.h"
#import "NEXSensorItem.h"

NS_ASSUME_NONNULL_BEGIN

/**
 * Contains a NEIndoorOutdoor value which represents whether a user is indoors, outdoors, or
 * enclosed.
 *
 * Enclosed in this case means that the user is outside, but under some sort of canopy.
 * This could be a bus shelter or a train for example.
 */
@interface NEXIndoorOutdoor : NEXSensorItem

/**
 * Default constructor.
 */
- (instancetype)init;

/**
 * Default constructor.
 */
+ (instancetype)new;

/**
 * Conversion copy constructor.
 * @param indoorOutdoor NEIndoorOutdoor to copy from.
 */
- (instancetype)initWithIndoorOutdoor:(NEIndoorOutdoor)indoorOutdoor;

/**
 * Conversion copy constructor.
 * @param indoorOutdoor NEIndoorOutdoor to copy from.
 * @param confidence An optional confidence level from 0.0 (min) to 1.0 (max).
 */
- (instancetype)initWithIndoorOutdoor:(NEIndoorOutdoor)indoorOutdoor confidence:(double)confidence;

/**
 * @param state State to assume.
 */
- (instancetype)initWithState:(NEIndoorOutdoorState)state;

/**
 * @param state State to assume.
 * @param confidence An optional confidence level from 0.0 (min) to 1.0 (max).
 */
- (instancetype)initWithState:(NEIndoorOutdoorState)state confidence:(double)confidence;

/**
 * Parse a string in serialized form.
 * @param string The serialized string, as generated by serialize()
 *
 * @return `nil` if unserialization failed.
 */
+ (instancetype _Nullable)unserializeWithString:(NSString*)string;

@property(nonatomic, readonly) NEIndoorOutdoor value DEPRECATED_ATTRIBUTE;

/**
 * Whether a user is indoors, outdoors, or enclosed.
 */
@property(nonatomic, readwrite) NEIndoorOutdoorState state;

/**
 * @return A hash value representing the state of the Type.
 *          Can be used for checking equality.
 */
@property(nonatomic, readonly) NSUInteger hash;

/**
 * @return The name of the concrete value class extending NEXSensorItem.
 */
@property(nonatomic, readonly) NSString* type;

/**
 * @return A human-readable format of the held data.
 */
@property(nonatomic, readonly) NSString* description;

/**
 * @return A machine-readable format of the held data.  Returns `nil` if @p type is invalid, or if
 * serialization failed.
 */
- (NSString* _Nullable)serialize;

+ (NSString*)stringFromState:(NEIndoorOutdoorState)state;

/**
 * Strict equality comparison.
 *
 * @see NEIndoorOutdoor_isEqual
 *
 * @param object Value to compare with.
 */
- (BOOL)isEqual:(id _Nullable)object;

/**
 * Convert the Objective-C class to a C-compatible struct.
 */
- (NEIndoorOutdoor)c_val;

@end
NS_ASSUME_NONNULL_END
